#include <iostream>
#include <cmath>

#define tip int

using namespace std;

int main()
{
    std::ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    tip n;
    tip ukupnaAnd = -1;
    tip ukupnaXor = 0;
    tip brojOperacija = 0;
    tip tren;

    cin >> n;

    for (; n > 0; --n){
        cin >> tren;
        if (!(tren & 1)){//da li nije paran
            ++tren;
            ++brojOperacija;
        }
        //cout << tren << " ";
        ukupnaAnd = ukupnaAnd & tren;
        ukupnaXor = ukupnaXor ^ tren;
    }

    //cout << endl <<ukupnaAnd << endl << ukupnaXor << endl;
    tip counter = -1;
    while (!ukupnaXor){
            brojOperacija += 2;
            if (counter == -1){
                ukupnaXor ^= ukupnaXor;
            }
            else{
                ukupnaXor ^= ukupnaXor ^ (int)pow(2, counter);
                if (counter != 0) ukupnaXor ^= (int) pow(2, counter - 1);
            }
    }
    cout << brojOperacija << endl;



    return 0;
}